﻿package  
{
	/**
	 * ...
	 * @author eiki
	 * 
	 * 使い方：
	 * 1. インスタンスをnewする
	 * 2. CallHighScoreで好きな機能を呼ぶ
	 * * 1 ... 1～100位のハイスコアランキング
	 * * 2 ... スコアの挿入（重複を削除）
	 * * 3 ... 100位のスコアを取得（居ないなら0）
	 */
	
	import flash.net.URLRequest;
	import flash.net.URLVariables;
	import flash.net.URLLoader;
	import flash.net.URLRequestMethod;
	import flash.net.URLLoaderDataFormat;
	import flash.events.Event;
	import Date;
	
	public class CScoreDeliver 
	{
		public var m_UserName:String;
		public var m_UserHash:String;
		public var m_HighScore:int;
		public var m_Result:String;
		
		public var m_Complete:Boolean;
		
		public function CScoreDeliver() 
		{
			m_UserName = "No Name";
			m_UserHash = "";
			m_HighScore = 0;
			m_Complete = false;
			m_Result = "";
		}
		
		public function CallScoreRanking(in_Mode:int):void {
			m_Complete = false;
			
			var request:URLRequest = new URLRequest ( "highscorelist.php" );
			var sendMessage:URLVariables = new URLVariables();
			sendMessage.SendMode = in_Mode;
			sendMessage.username = m_UserName;
			sendMessage.userscore = m_HighScore;
			sendMessage.userhash = m_UserHash;
			
			request.method = URLRequestMethod.POST;  
			request.data = sendMessage;			// 結びつけていく
			
			var loader:URLLoader = new URLLoader (request);
			loader.dataFormat = URLLoaderDataFormat.VARIABLES;
			loader.addEventListener(Event.COMPLETE, onComplete);
			loader.load(request);
		}
		
		private function onComplete(event:Event):void {
			var res:URLVariables = new URLVariables( event.target.data );  
			m_Result = res.comp;
			m_Complete = true;
		}
		
		public function IsComplete():Boolean { return m_Complete; }
		public function GetResult():String {
			if (!m_Complete) return null;
			m_Complete = false;
			if (!m_Result) m_Result = "ERROR: Can't Read HighScoreList.";
			return m_Result;
		}
		
		public function CreateUserHash():String {
			var hsnum:int = 0;
			var unlength:int = m_UserName.length;
			var dt:Date = new Date();
			for(var i:int = 0;i<unlength;i++) hsnum += Number(m_UserName.charCodeAt(i));
			m_UserHash = hsnum.toString() + dt.getTime().toString();
			return m_UserHash;
		}
		
	}

}